org.apache.lucene.queryparser.classic

## Class QueryParserBase

- java.lang.Object
- - org.apache.lucene.util.QueryBuilder
  - - org.apache.lucene.queryparser.classic.QueryParserBase

- All Implemented Interfaces:
    CommonQueryParserConfiguration
  Direct Known Subclasses:
    QueryParser

      public abstract class QueryParserBase
      extends QueryBuilder
      implements CommonQueryParserConfiguration

  This class is overridden by QueryParser in QueryParser.jj and acts to separate the majority of the Java code from the .jj grammar file.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static QueryParser.Operator` | `AND_OPERATOR` Alternative form of QueryParser.Operator.AND
    `protected String` | `field`
    `static QueryParser.Operator` | `OR_OPERATOR` Alternative form of QueryParser.Operator.OR

    - ### Fields inherited from class org.apache.lucene.util.QueryBuilder

      `analyzer, autoGenerateMultiTermSynonymsPhraseQuery, enableGraphQueries, enablePositionIncrements`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `QueryParserBase()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `addClause(List<BooleanClause> clauses, int conj, int mods, Query q)`
    `protected void` | `addMultiTermClauses(List<BooleanClause> clauses, Query q)` Adds clauses generated from analysis over text containing whitespace.
    `static String` | `escape(String s)` Returns a String where those characters that QueryParser expects to be escaped are escaped by a preceding `\`.
    `boolean` | `getAllowLeadingWildcard()`
    `boolean` | `getAnalyzeRangeTerms()`
    `boolean` | `getAutoGeneratePhraseQueries()`
    `protected Query` | `getBooleanQuery(List<BooleanClause> clauses)` Factory method for generating query, given a set of clauses.
    `DateTools.Resolution` | `getDateResolution(String fieldName)` Returns the date resolution that is used by RangeQueries for the given field.
    `QueryParser.Operator` | `getDefaultOperator()` Gets implicit operator setting, which will be either AND_OPERATOR or OR_OPERATOR.
    `String` | `getField()`
    `protected Query` | `getFieldQuery(String field, String queryText, boolean quoted)`
    `protected Query` | `getFieldQuery(String field, String queryText, int slop)` Base implementation delegates to `getFieldQuery(String,String,boolean)`.
    `float` | `getFuzzyMinSim()` Get the minimal similarity for fuzzy queries.
    `int` | `getFuzzyPrefixLength()` Get the prefix length for fuzzy queries.
    `protected Query` | `getFuzzyQuery(String field, String termStr, float minSimilarity)` Factory method for generating a query (similar to `getWildcardQuery(java.lang.String, java.lang.String)`).
    `Locale` | `getLocale()` Returns current locale, allowing access by subclasses.
    `boolean` | `getLowercaseExpandedTerms()`
    `int` | `getMaxDeterminizedStates()`
    `MultiTermQuery.RewriteMethod` | `getMultiTermRewriteMethod()`
    `int` | `getPhraseSlop()` Gets the default slop for phrases.
    `protected Query` | `getPrefixQuery(String field, String termStr)` Factory method for generating a query (similar to `getWildcardQuery(java.lang.String, java.lang.String)`).
    `protected Query` | `getRangeQuery(String field, String part1, String part2, boolean startInclusive, boolean endInclusive)`
    `protected Query` | `getRegexpQuery(String field, String termStr)` Factory method for generating a query.
    `TimeZone` | `getTimeZone()`
    `protected Query` | `getWildcardQuery(String field, String termStr)` Factory method for generating a query.
    `void` | `init(String f, Analyzer a)` Initializes a query parser.
    `protected BooleanClause` | `newBooleanClause(Query q, BooleanClause.Occur occur)` Builds a new BooleanClause instance
    `protected Query` | `newFieldQuery(Analyzer analyzer, String field, String queryText, boolean quoted)`
    `protected Query` | `newFuzzyQuery(Term term, float minimumSimilarity, int prefixLength)` Builds a new FuzzyQuery instance
    `protected Query` | `newMatchAllDocsQuery()` Builds a new MatchAllDocsQuery instance
    `protected Query` | `newPrefixQuery(Term prefix)` Builds a new PrefixQuery instance
    `protected Query` | `newRangeQuery(String field, String part1, String part2, boolean startInclusive, boolean endInclusive)` Builds a new `TermRangeQuery` instance
    `protected Query` | `newRegexpQuery(Term regexp)` Builds a new RegexpQuery instance
    `protected Query` | `newWildcardQuery(Term t)` Builds a new WildcardQuery instance
    `Query` | `parse(String query)` Parses a query string, returning a `Query`.
    `abstract void` | `ReInit(CharStream stream)`
    `void` | `setAllowLeadingWildcard(boolean allowLeadingWildcard)` Set to `true` to allow leading wildcard characters.
    `void` | `setAnalyzeRangeTerms(boolean analyzeRangeTerms)` Set whether or not to analyze range terms when constructing `TermRangeQuery`s.
    `void` | `setAutoGeneratePhraseQueries(boolean value)` Set to true if phrase queries will be automatically generated when the analyzer returns more than one term from whitespace delimited text.
    `void` | `setDateResolution(DateTools.Resolution dateResolution)` Sets the default date resolution used by RangeQueries for fields for which no specific date resolutions has been set.
    `void` | `setDateResolution(String fieldName, DateTools.Resolution dateResolution)` Sets the date resolution used by RangeQueries for a specific field.
    `void` | `setDefaultOperator(QueryParser.Operator op)` Sets the boolean operator of the QueryParser.
    `void` | `setFuzzyMinSim(float fuzzyMinSim)` Set the minimum similarity for fuzzy queries.
    `void` | `setFuzzyPrefixLength(int fuzzyPrefixLength)` Set the prefix length for fuzzy queries.
    `void` | `setLocale(Locale locale)` Set locale used by date range parsing, lowercasing, and other locale-sensitive operations.
    `void` | `setLowercaseExpandedTerms(boolean lowercaseExpandedTerms)` Whether terms of wildcard, prefix, fuzzy and range queries are to be automatically lower-cased or not.
    `void` | `setMaxDeterminizedStates(int maxDeterminizedStates)`
    `void` | `setMultiTermRewriteMethod(MultiTermQuery.RewriteMethod method)` By default QueryParser uses `MultiTermQuery.CONSTANT_SCORE_REWRITE` when creating a `PrefixQuery`, `WildcardQuery` or `TermRangeQuery`.
    `void` | `setPhraseSlop(int phraseSlop)` Sets the default slop for phrases.
    `void` | `setTimeZone(TimeZone timeZone)`
    `abstract Query` | `TopLevelQuery(String field)`

    - ### Methods inherited from class org.apache.lucene.util.QueryBuilder

      `add, analyzeBoolean, analyzeGraphBoolean, analyzeGraphPhrase, analyzeMultiBoolean, analyzeMultiPhrase, analyzePhrase, analyzeTerm, createBooleanQuery, createBooleanQuery, createFieldQuery, createFieldQuery, createMinShouldMatchQuery, createPhraseQuery, createPhraseQuery, createSpanQuery, getAnalyzer, getAutoGenerateMultiTermSynonymsPhraseQuery, getEnableGraphQueries, getEnablePositionIncrements, newBooleanQuery, newGraphSynonymQuery, newMultiPhraseQueryBuilder, newSynonymQuery, newTermQuery, setAnalyzer, setAutoGenerateMultiTermSynonymsPhraseQuery, setEnableGraphQueries, setEnablePositionIncrements`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.lucene.queryparser.flexible.standard.CommonQueryParserConfiguration

      `getAnalyzer, getEnablePositionIncrements, setEnablePositionIncrements`

- - ### Field Detail

    - #### AND_OPERATOR

          public static final QueryParser.Operator AND_OPERATOR

      Alternative form of QueryParser.Operator.AND

    - #### OR_OPERATOR

          public static final QueryParser.Operator OR_OPERATOR

      Alternative form of QueryParser.Operator.OR

    - #### field

          protected String field

  - ### Constructor Detail

    - #### QueryParserBase

          protected QueryParserBase()

  - ### Method Detail

    - #### init

          public void init(String f,
                           Analyzer a)

      Initializes a query parser. Called by the QueryParser constructor
      Parameters:
        `f` - the default field for query terms.
        `a` - used to find terms in the query text.

    - #### ReInit

          public abstract void ReInit(CharStream stream)

    - #### TopLevelQuery

          public abstract Query TopLevelQuery(String field)
                                       throws ParseException

      Throws:
        `ParseException`

    - #### parse

          public Query parse(String query)
                      throws ParseException

      Parses a query string, returning a `Query`.
      Parameters:
        `query` - the query string to be parsed.
      Throws:
        `ParseException` - if the parsing fails

    - #### getField

          public String getField()

      Returns:
        Returns the default field.

    - #### getAutoGeneratePhraseQueries

          public final boolean getAutoGeneratePhraseQueries()

      See Also:
        `setAutoGeneratePhraseQueries(boolean)`

    - #### setAutoGeneratePhraseQueries

          public void setAutoGeneratePhraseQueries(boolean value)

      Set to true if phrase queries will be automatically generated when the analyzer returns more than one term from whitespace delimited text. NOTE: this behavior may not be suitable for all languages.

      Set to false if phrase queries should only be generated when surrounded by double quotes.

    - #### getFuzzyMinSim

          public float getFuzzyMinSim()

      Get the minimal similarity for fuzzy queries.
      Specified by:
        `getFuzzyMinSim` in interface `CommonQueryParserConfiguration`

    - #### setFuzzyMinSim

          public void setFuzzyMinSim(float fuzzyMinSim)

      Set the minimum similarity for fuzzy queries. Default is 2f.
      Specified by:
        `setFuzzyMinSim` in interface `CommonQueryParserConfiguration`

    - #### getFuzzyPrefixLength

          public int getFuzzyPrefixLength()

      Get the prefix length for fuzzy queries.
      Specified by:
        `getFuzzyPrefixLength` in interface `CommonQueryParserConfiguration`
      Returns:
        Returns the fuzzyPrefixLength.

    - #### setFuzzyPrefixLength

          public void setFuzzyPrefixLength(int fuzzyPrefixLength)

      Set the prefix length for fuzzy queries. Default is 0.
      Specified by:
        `setFuzzyPrefixLength` in interface `CommonQueryParserConfiguration`
      Parameters:
        `fuzzyPrefixLength` - The fuzzyPrefixLength to set.

    - #### setPhraseSlop

          public void setPhraseSlop(int phraseSlop)

      Sets the default slop for phrases. If zero, then exact phrase matches are required. Default value is zero.
      Specified by:
        `setPhraseSlop` in interface `CommonQueryParserConfiguration`

    - #### getPhraseSlop

          public int getPhraseSlop()

      Gets the default slop for phrases.
      Specified by:
        `getPhraseSlop` in interface `CommonQueryParserConfiguration`

    - #### setAllowLeadingWildcard

          public void setAllowLeadingWildcard(boolean allowLeadingWildcard)

      Set to `true` to allow leading wildcard characters.

      When set, `*` or `?` are allowed as the first character of a PrefixQuery and WildcardQuery. Note that this can produce very slow queries on big indexes.

      Default: false.

      Specified by:
        `setAllowLeadingWildcard` in interface `CommonQueryParserConfiguration`

    - #### getAllowLeadingWildcard

          public boolean getAllowLeadingWildcard()

      Specified by:
        `getAllowLeadingWildcard` in interface `CommonQueryParserConfiguration`
      See Also:
        `setAllowLeadingWildcard(boolean)`

    - #### setDefaultOperator

          public void setDefaultOperator(QueryParser.Operator op)

      Sets the boolean operator of the QueryParser. In default mode (`OR_OPERATOR`) terms without any modifiers are considered optional: for example `capital of Hungary` is equal to `capital OR of OR Hungary`.
      In `AND_OPERATOR` mode terms are considered to be in conjunction: the above mentioned query is parsed as `capital AND of AND Hungary`

    - #### getDefaultOperator

          public QueryParser.Operator getDefaultOperator()

      Gets implicit operator setting, which will be either AND_OPERATOR or OR_OPERATOR.

    - #### setLowercaseExpandedTerms

          public void setLowercaseExpandedTerms(boolean lowercaseExpandedTerms)

      Whether terms of wildcard, prefix, fuzzy and range queries are to be automatically lower-cased or not. Default is `true`.
      Specified by:
        `setLowercaseExpandedTerms` in interface `CommonQueryParserConfiguration`

    - #### getLowercaseExpandedTerms

          public boolean getLowercaseExpandedTerms()

      Specified by:
        `getLowercaseExpandedTerms` in interface `CommonQueryParserConfiguration`
      See Also:
        `setLowercaseExpandedTerms(boolean)`

    - #### setMultiTermRewriteMethod

          public void setMultiTermRewriteMethod(MultiTermQuery.RewriteMethod method)

      By default QueryParser uses `MultiTermQuery.CONSTANT_SCORE_REWRITE` when creating a `PrefixQuery`, `WildcardQuery` or `TermRangeQuery`. This implementation is generally preferable because it a) Runs faster b) Does not have the scarcity of terms unduly influence score c) avoids any `BooleanQuery.TooManyClauses` exception. However, if your application really needs to use the old-fashioned `BooleanQuery` expansion rewriting and the above points are not relevant then use this to change the rewrite method.
      Specified by:
        `setMultiTermRewriteMethod` in interface `CommonQueryParserConfiguration`

    - #### getMultiTermRewriteMethod

          public MultiTermQuery.RewriteMethod getMultiTermRewriteMethod()

      Specified by:
        `getMultiTermRewriteMethod` in interface `CommonQueryParserConfiguration`
      See Also:
        `setMultiTermRewriteMethod(org.apache.lucene.search.MultiTermQuery.RewriteMethod)`

    - #### setLocale

          public void setLocale(Locale locale)

      Set locale used by date range parsing, lowercasing, and other locale-sensitive operations.
      Specified by:
        `setLocale` in interface `CommonQueryParserConfiguration`

    - #### getLocale

          public Locale getLocale()

      Returns current locale, allowing access by subclasses.
      Specified by:
        `getLocale` in interface `CommonQueryParserConfiguration`

    - #### setTimeZone

          public void setTimeZone(TimeZone timeZone)

      Specified by:
        `setTimeZone` in interface `CommonQueryParserConfiguration`

    - #### getTimeZone

          public TimeZone getTimeZone()

      Specified by:
        `getTimeZone` in interface `CommonQueryParserConfiguration`

    - #### setDateResolution

          public void setDateResolution(DateTools.Resolution dateResolution)

      Sets the default date resolution used by RangeQueries for fields for which no specific date resolutions has been set. Field specific resolutions can be set with `setDateResolution(String, org.apache.lucene.document.DateTools.Resolution)`.
      Specified by:
        `setDateResolution` in interface `CommonQueryParserConfiguration`
      Parameters:
        `dateResolution` - the default date resolution to set

    - #### setDateResolution

          public void setDateResolution(String fieldName,
                                        DateTools.Resolution dateResolution)

      Sets the date resolution used by RangeQueries for a specific field.
      Parameters:
        `fieldName` - field for which the date resolution is to be set
        `dateResolution` - date resolution to set

    - #### getDateResolution

          public DateTools.Resolution getDateResolution(String fieldName)

      Returns the date resolution that is used by RangeQueries for the given field. Returns null, if no default or field specific date resolution has been set for the given field.

    - #### setAnalyzeRangeTerms

          public void setAnalyzeRangeTerms(boolean analyzeRangeTerms)

      Set whether or not to analyze range terms when constructing `TermRangeQuery`s. For example, setting this to true can enable analyzing terms into collation keys for locale-sensitive `TermRangeQuery`.
      Parameters:
        `analyzeRangeTerms` - whether or not terms should be analyzed for RangeQuerys

    - #### getAnalyzeRangeTerms

          public boolean getAnalyzeRangeTerms()

      Returns:
        whether or not to analyze range terms when constructing `TermRangeQuery`s.

    - #### setMaxDeterminizedStates

          public void setMaxDeterminizedStates(int maxDeterminizedStates)

      Parameters:
        `maxDeterminizedStates` - the maximum number of states that determinizing a regexp query can result in. If the query results in any more states a TooComplexToDeterminizeException is thrown.

    - #### getMaxDeterminizedStates

          public int getMaxDeterminizedStates()

      Returns:
        the maximum number of states that determinizing a regexp query can result in. If the query results in any more states a TooComplexToDeterminizeException is thrown.

    - #### addClause

          protected void addClause(List<BooleanClause> clauses,
                                   int conj,
                                   int mods,
                                   Query q)

    - #### addMultiTermClauses

          protected void addMultiTermClauses(List<BooleanClause> clauses,
                                             Query q)

      Adds clauses generated from analysis over text containing whitespace. There are no operators, so the query's clauses can either be MUST (if the default operator is AND) or SHOULD (default OR). If all of the clauses in the given Query are TermQuery-s, this method flattens the result by adding the TermQuery-s individually to the output clause list; otherwise, the given Query is added as a single clause including its nested clauses.

    - #### getFieldQuery

          protected Query getFieldQuery(String field,
                                        String queryText,
                                        boolean quoted)
                                 throws ParseException

      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### newFieldQuery

          protected Query newFieldQuery(Analyzer analyzer,
                                        String field,
                                        String queryText,
                                        boolean quoted)
                                 throws ParseException

      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getFieldQuery

          protected Query getFieldQuery(String field,
                                        String queryText,
                                        int slop)
                                 throws ParseException

      Base implementation delegates to `getFieldQuery(String,String,boolean)`. This method may be overridden, for example, to return a SpanNearQuery instead of a PhraseQuery.
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getRangeQuery

          protected Query getRangeQuery(String field,
                                        String part1,
                                        String part2,
                                        boolean startInclusive,
                                        boolean endInclusive)
                                 throws ParseException

      Throws:
        `ParseException`

    - #### newBooleanClause

          protected BooleanClause newBooleanClause(Query q,
                                                   BooleanClause.Occur occur)

      Builds a new BooleanClause instance
      Parameters:
        `q` - sub query
        `occur` - how this clause should occur when matching documents
      Returns:
        new BooleanClause instance

    - #### newPrefixQuery

          protected Query newPrefixQuery(Term prefix)

      Builds a new PrefixQuery instance
      Parameters:
        `prefix` - Prefix term
      Returns:
        new PrefixQuery instance

    - #### newRegexpQuery

          protected Query newRegexpQuery(Term regexp)

      Builds a new RegexpQuery instance
      Parameters:
        `regexp` - Regexp term
      Returns:
        new RegexpQuery instance

    - #### newFuzzyQuery

          protected Query newFuzzyQuery(Term term,
                                        float minimumSimilarity,
                                        int prefixLength)

      Builds a new FuzzyQuery instance
      Parameters:
        `term` - Term
        `minimumSimilarity` - minimum similarity
        `prefixLength` - prefix length
      Returns:
        new FuzzyQuery Instance

    - #### newRangeQuery

          protected Query newRangeQuery(String field,
                                        String part1,
                                        String part2,
                                        boolean startInclusive,
                                        boolean endInclusive)

      Builds a new `TermRangeQuery` instance
      Parameters:
        `field` - Field
        `part1` - min
        `part2` - max
        `startInclusive` - true if the start of the range is inclusive
        `endInclusive` - true if the end of the range is inclusive
      Returns:
        new `TermRangeQuery` instance

    - #### newMatchAllDocsQuery

          protected Query newMatchAllDocsQuery()

      Builds a new MatchAllDocsQuery instance
      Returns:
        new MatchAllDocsQuery instance

    - #### newWildcardQuery

          protected Query newWildcardQuery(Term t)

      Builds a new WildcardQuery instance
      Parameters:
        `t` - wildcard term
      Returns:
        new WildcardQuery instance

    - #### getBooleanQuery

          protected Query getBooleanQuery(List<BooleanClause> clauses)
                                   throws ParseException

      Factory method for generating query, given a set of clauses. By default creates a boolean query composed of clauses passed in. Can be overridden by extending classes, to modify query being returned.
      Parameters:
        `clauses` - List that contains `BooleanClause` instances to join.
      Returns:
        Resulting `Query` object.
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getWildcardQuery

          protected Query getWildcardQuery(String field,
                                           String termStr)
                                    throws ParseException

      Factory method for generating a query. Called when parser parses an input term token that contains one or more wildcard characters (? and *), but is not a prefix term token (one that has just a single * character at the end)

      Depending on settings, prefix term may be lower-cased automatically. It will not go through the default Analyzer, however, since normal Analyzers are unlikely to work properly with wildcard templates.

      Can be overridden by extending classes, to provide custom handling for wildcard queries, which may be necessary due to missing analyzer calls.

      Parameters:
        `field` - Name of the field query will use.
        `termStr` - Term token that contains one or more wild card characters (? or *), but is not simple prefix term
      Returns:
        Resulting `Query` built for the term
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getRegexpQuery

          protected Query getRegexpQuery(String field,
                                         String termStr)
                                  throws ParseException

      Factory method for generating a query. Called when parser parses an input term token that contains a regular expression query.

      Depending on settings, pattern term may be lower-cased automatically. It will not go through the default Analyzer, however, since normal Analyzers are unlikely to work properly with regular expression templates.

      Can be overridden by extending classes, to provide custom handling for regular expression queries, which may be necessary due to missing analyzer calls.

      Parameters:
        `field` - Name of the field query will use.
        `termStr` - Term token that contains a regular expression
      Returns:
        Resulting `Query` built for the term
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getPrefixQuery

          protected Query getPrefixQuery(String field,
                                         String termStr)
                                  throws ParseException

      Factory method for generating a query (similar to `getWildcardQuery(java.lang.String, java.lang.String)`). Called when parser parses an input term token that uses prefix notation; that is, contains a single '*' wildcard character as its last character. Since this is a special case of generic wildcard term, and such a query can be optimized easily, this usually results in a different query object.

      Depending on settings, a prefix term may be lower-cased automatically. It will not go through the default Analyzer, however, since normal Analyzers are unlikely to work properly with wildcard templates.

      Can be overridden by extending classes, to provide custom handling for wild card queries, which may be necessary due to missing analyzer calls.

      Parameters:
        `field` - Name of the field query will use.
        `termStr` - Term token to use for building term for the query (without trailing '*' character!)
      Returns:
        Resulting `Query` built for the term
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getFuzzyQuery

          protected Query getFuzzyQuery(String field,
                                        String termStr,
                                        float minSimilarity)
                                 throws ParseException

      Factory method for generating a query (similar to `getWildcardQuery(java.lang.String, java.lang.String)`). Called when parser parses an input term token that has the fuzzy suffix (~) appended.
      Parameters:
        `field` - Name of the field query will use.
        `termStr` - Term token to use for building term for the query
      Returns:
        Resulting `Query` built for the term
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### escape

          public static String escape(String s)

      Returns a String where those characters that QueryParser expects to be escaped are escaped by a preceding `\`.

Copyright © 2000-2018 Apache Software Foundation. All Rights Reserved.